//
//  DBHelper.swift
//  Alamofire
//
//  Created by Amit satyapanthi on 30/03/19.
//

import Foundation
//import SQLCipher
import FMDB
import SwiftyJSON

class DBHelper{
    
    static let OPTIMIZE_MAIN_TABLE = true
    
    
    
    static let TABLE_CPM_CUSTOMER_DISPATCH = "CPM_Customer_Dispatch"
    static let TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS = "CPM_Customer_Dispatch_Product_Details"
    static let TABLE_CPM_CUSTOMER_RECEIVE = "CPM_Customer_Receive"
    static let TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS = "CPM_Customer_Receive_Product_Details"
    static let TABLE_CPM_STRICKER = "CPM_Sticker"
    static let TABLE_CPM_STRICKER_Details = "CPM_Sticker_Details"
    static let TABLE_CPM_CUSTOMER_RECEIVE_DAMAGE = "CPM_Customer_Receive_Damage"
    static let TABLE_CPM_CUSTOMER_OPENING_STOCK = "CPM_Customer_Opening_Stock"
    static let TABLE_CPM_CUSTOMER_PENDING_ORDER = "CPM_Customer_Pending_Order"
    static let TABLE_CPM_CUSTOMER_PENDING_DISPATCH = "CPM_Customer_Pending_Dispatch"
    static let TABLE_CPM_DI_DETAILS = "CPM_DI_Details"
    static let TABLE_STATUS_MST = "Status_Mst"
    static let TABLE_PRODUCT_MAIN_GROUP_MST = "Product_Main_Group_Mst"
    static let TABLE_PRODUCT_BUSINESS_GROUP_MST = "Product_Business_Group_Mst"
    static let TABLE_PRD_MST = "PRD_Mst"
    static let TABLE_PRODUCT_SKU_MST = "Product_SKU_Mst"
    static let TABLE_PRODUCT_SKU_CONVERSION = "Product_SKU_Conversion"
    static let TABLE_COUNTRY_MST = "Countries_Mst"
    static let TABLE_POLITICAL_GEOGRAPHY_LEVEL_REGIONAL_MST = "Political_Geography_Level_Regional_Mst"
    static let TABLE_POLITICAL_GEOGRAPHY_LEVEL_COUNTRY_MST = "Political_Geography_Level_Country_Mst"
    static let TABLE_POLITICAL_GEOGRAPHY_DETAILS = "Political_Geography_Details"
    static let TABLE_SYSTEM_CONFIGURATION_MST = "SystemConfiguration_Mst"
    static let TABLE_EMPLOYEE_TYPE_MST = "Employee_Type_Mst"
    static let TABLE_CUSTOMER_TYPE_REGIONAL_MST = "Customer_Type_Regional_Mst"
    static let TABLE_CUSTOMER_TYPE_COUNTRY_MST = "Customer_Type_Country_Mst"
    static let TABLE_PERSON_MST = "Person_Mst"
    static let TABLE_CPM_DAMAGE_TYPE = "CPM_Damage_Type"
    static let TABLE_UOM_MST = "UOM_Mst"
    static let TABLE_MENU_MST = "Menu_Mst"
    static let TABLE_PSKU_BATCH_STOCK = "CPM_PSKU_Batch_Stock"
    static let TABLE_CUSTOMER_PARTNER_MST = "Customer_Partner_Mst"
    static let TABLE_CPM_CUSTOMER_STICKER_DAMAGE = "CPM_Customer_Sticker_Damage"
    static let TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE = "CPM_Customer_Sticker_Damage_Remove"
    static let TABLE_LOGIN_DETAILS = "LoginDetails"
    static let TABLE_CPM_PALLET_MST = "CPM_Pallet_Mst"
    
    static let TABLE_LAB_STORE = "LAB_Store"
    static let TABLE_LAB_MATERIAL_ALLOCATION = "LAB_Material_Allocation"
    static let TABLE_LAB_MATERIAL_RETURN = "LAB_Material_Return"
    static let TABLE_LAB_CUSTOMER_DISPATCH = "LAB_Customer_Dispatch"
    static let TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS = "LAB_Customer_Dispatch_Product_Details"
    static let TABLE_LAB_DISPOSAL = "LAB_Disposal"
    static let TABLE_LAB_STICKER_DETAILS = "LAB_Sticker_Details"
    static let TABLE_CPM_Customer_Sticker_Scrap = "CPM_Customer_Sticker_Scrap";
    static let TABLE_CPM_Customer_Sticker_Consume = "CPM_Customer_Sticker_Consume";
    static let TABLE_CPM_GENERAL_RECEIVE = "CPM_General_Receive";
    
    // IFFCO TABLE NAME
    
    static let IFFCO_TABLE_CPM_CUSTOMER_DISPATCH = "CPM_CUSTOMER_DISPATCH";
    static let IFFCO_TABLE_CPM_CUSTOMER_STICKER_BLOCK = "CPM_CUSTOMER_STICKER_BLOCK";
       static let IFFCO_TABLE_CPM_CUSTOMER_STICKER_BLOCK_REMOVE = "CPM_CUSTOMER_STICKER_BLOCK_REMOVE";
       static let IFFCO_TABLE_LOGIN_DETAILS = "LOGIN_DETAILS";
       static let IFFCO_TABLE_LOGIN_FORM_DETAILS = "LOGIN_FORM_DETAILS";
       static let IFFCO_TABLE_LOGIN_FAIL_ATTEMPT_DETAILS = "LOGIN_FAIL_ATTEMPT_DETAILS";
       static let IFFCO_TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS = "CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS";
       static let IFFCO_TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS = "CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS";
       static let IFFCO_TABLE_CPM_STRICKER_Details = "CPM_STICKER_DETAILS";
       static let IFFCO_TABLE_CPM_SKU_STRICKER_Details = "CPM_SKU_STICKER_DETAILS";
       static let IFFCO_TABLE_CPM_PALLET_MST = "CPM_PALLET_MST";
       static let IFFCO_TABLE_PERSON_MST = "PERSON_MST";
       static let IFFCO_TABLE_CUSTOMER_MST = "CUSTOMER_MST";
       static let IFFCO_TABLE_CUSTOMER_TYPE_MST = "CUSTOMER_TYPE_MST";
       static let IFFCO_TABLE_CPM_BLOCK_TYPE = "CPM_BLOCK_TYPE";
       static let IFFCO_TABLE_PRODUCT_SKU_MST = "PRODUCT_SKU_MST";
       static let IFFCO_TABLE_POLITICAL_GEOGRAPHY_DETAILS = "POLITICAL_GEOGRAPHY_DETAILS";
       static let IFFCO_TABLE_POLITICAL_GEOGRAPHY_LEVEL_MST = "POLITICAL_GEOGRAPHY_LEVEL_MST";
    
    
    static let TABLE_TOLLER_DISPATCH_PRODUCT = "bf_ishop_toller_dispatch_product";
    static let TABLE_CFA_DISPATCH_PRODUCT = "bf_ishop_cfa_dispatch_product";
    static let TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = "bf_ishop_distributor_dispatch_product";
    static let TABLE_RETAILER_DISPATCH_PRODUCT = "bf_ishop_retailer_dispatch_product";
    static let TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT = "bf_ishop_distributor_received_product";
    static let TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT = "bf_ishop_retailer_received_product";
    static let TABLE_CFA_RETURN_PRODUCT = "bf_ishop_cfa_return_product";
    static let TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT = "bf_ishop_distributor_return_request_product";
    static let TABLE_CustomerType_Details = "CustomerType_Details";
    static let TABLE_CFA_DAMAGE = "bf_ishop_cfa_damage";
    static let TABLE_CFA_DAMAGE_PRODUCT = "bf_ishop_cfa_damage_product";
    static let TABLE_DISTRIBUTOR_DAMAGE = "bf_ishop_distributor_damage";
    static let TABLE_DISTRIBUTOR_DAMAGE_PRODUCT = "bf_ishop_distributor_damage_product";
    static let TABLE_RETAILER_DAMAGE = "bf_ishop_retailer_damage";
    static let TABLE_RETAILER_DAMAGE_PRODUCT = "bf_ishop_retailer_damage_product";
    static let TABLE_HELP_VIDEO_DETAIL = "bf_master_cpm_help_video_details";
    static let TABLE_SAVE_OFFLINE_LOG = "bf_ishop_save_offline_log_android_cpm";
    static let TABLE_DEVICE_TOKEN = "table_device_token";
    static let TABLE_TRANSACTION_ERROR_LOG = "bf_ishop_transaction_error_log";
    static let TABLE_ISHOP_PALLET_DETAILS="bf_ishop_pallet_details";
    static let TABLE_TOLLER_DISPATCH = "bf_ishop_toller_dispatch";
    static let TABLE_RETAILER_DISPATCH = "bf_ishop_retailer_dispatch";
    static let TABLE_CFA_DISPATCH = "bf_ishop_cfa_dispatch";
    static let TABLE_ISHOP_SAMPLE_DISPATCH = "bf_ishop_sample_dispatch";
    static let TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT = "bf_ishop_sample_dispatch_product";
    static let TABLE_CFA_RETURN = "bf_ishop_cfa_return";
    static let TABLE_DISTRIBUTOR_DISPATCH = "bf_ishop_distributor_dispatch";
    static let TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED = "bf_ishop_distributor_received";
    static let TABLE_BF_ISHOP_RETAILER_RECEIVED = "bf_ishop_retailer_received";
    static let TABLE_DISTRIBUTOR_RETURN_REQUEST = "bf_ishop_distributor_return_request";
    static let TABLE_SALES_REP_INITIATED_PRODUCT = "bf_ishop_sales_rep_initiated_product";
    static let TABLE_DISTRIBUTOR_RETURN = "bf_ishop_distributor_return";
    static let KEY_SYNC_FLAG = "sync_flag";
    static let KEY_DISTRIBUTOR_RETURN_ID = "distributor_return_id";
    static let KEY_CUSTOMER_FROM_ID = "customer_from_id";
    static let KEY_CUSTOMER_TO_ID = "customer_to_id";
    static let KEY_CUSTOMER_TYPE_COUNTRY_ID = "customer_type_country_id";
    static let KEY_IS_NEW_CUSTOMER = "is_new_customer";
    static let KEY_RETURN_DATE = "return_date";
    static let KEY_COUNTRY_ID = "country_id";
    static let KEY_CREATED_BY_USER = "created_by_user";
    static let KEY_MODIFIED_BY_USER = "modified_by_user";
    static let KEY_STATUS = "status";
    static let KEY_CREATE_ON = "created_on";
    static let KEY_MODIFIED_ON = "modified_on";
    static let KEY_SYNC_CODE = "sync_code";
    static let KEY_SYNC_DATE = "sync_date";
    static let KEY_SYNC_USER = "sync_by_user";
    static let TABLE_DISTRIBUTOR_RETURN_PRODUCT = "bf_ishop_distributor_return_product";
    static let KEY_DISTRIBUTOR_RETURN_PRODUCT_ID = "distributor_return_product_id";
    static let KEY_PRODUCT_SKU_ID = "product_sku_id";
    static let KEY_STICKER_DETAILS_ID = "sticker_details_id";
    static let KEY_BTC_NO_OUT = "btc_no_out";
    static let KEY_QR_CODE_OUT = "qr_code_out";
    static let KEY_QUANTITY = "quantity";
    static let KEY_AMOUNT = "amount";
    static let KEY_IS_VALID = "is_valid";
    static let KEY_UNIT = "unit";
    static let KEY_QTY_KGL = "qty_kgl";
    
    
    static let TABLE_MASTER_REASON = "master_reason"
    static let KEY_REASON_ID = "reason_id"
    static let KEY_REASON_NAME = "reason_name"
    static let KEY_REASON_CODE = "reason_code"
    static let KEY_USED_FOR_ID = "used_for_id"
    static let KEY_USED_FOR_CODE = "used_for_code"
//    static let KEY_PALLET_DETAIL_ID = "pallet_details_id";

    
    static let KEY_IMEI = "imei_no";
    
    
    
    static let IS_EXPIRE_ENABLE = "is_expire_enable";
    static let CHR_SCM_CPM = "chr_scm_cpm";
    static let INT_SYNC_ALERT_MINUTES = "int_sync_alert_bg_minutes";
    static let INT_SCAN_ALERT_MINUTES = "int_scan_alert_bg_minutes";
    static let INT_SALES_RET_LIMIT = "int_sales_return_limit";
    static let IS_SYNC_POPUP = "is_Sync_PopUp";
    static let CHAR_PALLATE_ENABLE = "chr_pallet_enable";
    static let INT_SCAN_SCREEN = "intScanScreen";
    static let INT_SYNC_MINUTES = "int_sync_minutes";
    static let DIST_DISPATCH_MAX_DATE = "dispatch_date";
    static let DIST_RETURN_REQUEST_MAX_DATE = "return_request_date";
    static let DIST_DAMAGE_MAX_DATE = "damage_date";
    static let DIST_RET_RETURN_MAX_DATE = "ret_return_date";
    static let CFA_DISPATCH_MAX_DATE = "cfa_dispatch_date";

    static let INT_MINIMUM_MINS = "int_minimum_minutes";
    static let INT_MAXIMUM_MINS = "int_maximum_minutes";
    static let CHR_SCAN_TYPE_RADIO_BTN = "chr_scan_type_radio_btn";

    static let FTP_HOST = "ftp_host";
    static let FTP_USERNAME = "ftp_username";
    static let FTP_PASSWORD = "ftp_password";
    static let FTP_PORT = "ftp_port";

    //    CFA Damage Table And product Table
    static let CFA_DAMAGE_PRODUCT_ID = "cfa_damage_product_id";
    static let CFA_DAMAGE_ID = "cfa_damage_id";
    static let DAMAGE_DATE = "damage_date";
    static let ISDAMAGE = "isDamage";

    //    For Distributor Damage
    static let DISTRIBUTOR_DAMAGE_PRODUCT_ID = "distributor_damage_product_id";
    static let DISTRIBUTOR_DAMAGE_ID = "distributor_damage_id";

    //    For Retailer Damage
    static let RETAILER_DAMAGE_PRODUCT_ID = "retailer_damage_product_id";
    static let RETAILER_DAMAGE_ID = "retailer_damage_id";

    static let TABLE_SCHEME_MASTER = "Scheme_Master";
//    static let TABLE_CFA_DAMAGE = "bf_ishop_cfa_damage";
    static let TABLE_CFA_DAMAGE_COPY = "bf_ishop_cfa_damage_copy";
//    static let TABLE_CFA_DAMAGE_PRODUCT = "bf_ishop_cfa_damage_product";
//    static let TABLE_DISTRIBUTOR_DAMAGE = "bf_ishop_distributor_damage";
    static let TABLE_DISTRIBUTOR_DAMAGE_COPY = "bf_ishop_distributor_damage_copy";
//    static let TABLE_DISTRIBUTOR_DAMAGE_PRODUCT = "bf_ishop_distributor_damage_product";
//    static let TABLE_RETAILER_DAMAGE = "bf_ishop_retailer_damage";
    static let TABLE_RETAILER_DAMAGE_COPY = "bf_ishop_retailer_damage_copy";
//    static let TABLE_RETAILER_DAMAGE_PRODUCT = "bf_ishop_retailer_damage_product";
    static let TABLE_EXTRA_STICKER = "extra_sticker_detail";
    static let TABLE_EXTRA_STICKER_COPY = "extra_sticker_detail_copy";

    static let TABLE_REJECTED_ORDER = "table_rejected_order";
    static let TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE = "table_dispatch_batchwise_stock_calculate";
    static let TABLE_SCANNEDSTICKERS = "table_scannedsticker";
    static let TABLE_CHECK_MAX_DATE = "table_check_max_date";
    static let TABLE_LAST_SYNC_SCAN_DATE = "bf_last_sync_scan_status";
//    static let TABLE_TOLLER_DISPATCH = "bf_ishop_toller_dispatch";
    static let TABLE_TOLLER_DISPATCH_COPY = "bf_ishop_toller_dispatch_copy";
//    static let TABLE_TOLLER_DISPATCH_PRODUCT = "bf_ishop_toller_dispatch_product";
    static let TABLE_TOLLER_DISPATCH_PRODUCT_COPY = "bf_ishop_toller_dispatch_product_copy";
//    static let TABLE_CFA_DISPATCH = "bf_ishop_cfa_dispatch";
    static let TABLE_CFA_DISPATCH_COPY = "bf_ishop_cfa_dispatch_copy";
    // TABLE NAME
//    static let TABLE_CFA_DISPATCH_PRODUCT = "bf_ishop_cfa_dispatch_product";
    static let TABLE_CFA_DISPATCH_PRODUCT_COPY = "bf_ishop_cfa_dispatch_product_copy";
//    static let TABLE_DISTRIBUTOR_DISPATCH = "bf_ishop_distributor_dispatch";
    static let TABLE_DISTRIBUTOR_DISPATCH_COPY = "bf_ishop_distributor_dispatch_copy";
//    static let TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = "bf_ishop_distributor_dispatch_product";
    static let TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY = "bf_ishop_distributor_dispatch_product_copy";
    static let TABLE_NEW_CUSTOMER = "bf_master_new_customer";
//    static let TABLE_RETAILER_DISPATCH = "bf_ishop_retailer_dispatch";
    static let TABLE_RETAILER_DISPATCH_COPY = "bf_ishop_retailer_dispatch_copy";
//    static let TABLE_RETAILER_DISPATCH_PRODUCT = "bf_ishop_retailer_dispatch_product";
    static let TABLE_RETAILER_DISPATCH_PRODUCT_COPY = "bf_ishop_retailer_dispatch_product_copy";
    static let TABLE_RETAILER_RETURN = "bf_ishop_retailer_return";
    static let TABLE_RETAILER_RETURN_COPY = "bf_ishop_retailer_return_copy";
    static let TABLE_RETAILER_RETURN_PRODUCT = "bf_ishop_retailer_return_product";
    static let TABLE_RETAILER_RETURN_PRODUCT_COPY = "bf_ishop_retailer_return_product_copy";
//    static let TABLE_DISTRIBUTOR_RETURN = "bf_ishop_distributor_return";
    static let TABLE_DISTRIBUTOR_RETURN_COPY = "bf_ishop_distributor_return_copy";
//    static let TABLE_DISTRIBUTOR_RETURN_PRODUCT = "bf_ishop_distributor_return_product";
    static let TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY = "bf_ishop_distributor_return_product_copy";
//    static let TABLE_DISTRIBUTOR_RETURN_REQUEST = "bf_ishop_distributor_return_request";
    static let TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY = "bf_ishop_distributor_return_request_copy";
//    static let TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT = "bf_ishop_distributor_return_request_product";
    static let TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY =
            "bf_ishop_distributor_return_request_product_copy";
//    static let TABLE_CFA_RETURN = "bf_ishop_cfa_return";
    static let TABLE_CFA_RETURN_COPY = "bf_ishop_cfa_return_copy";
//    static let TABLE_CFA_RETURN_PRODUCT = "bf_ishop_cfa_return_product";
    static let TABLE_CFA_RETURN_PRODUCT_COPY = "bf_ishop_cfa_return_product_copy";
    static let TABLE_CPM_STOCK = "bf_ishop_cpm_stock";
    static let TABLE_CPM_STOCK_DETAILS = "bf_ishop_cpm_stock_details";
    static let TABLE_CUSTOMER_DETAILS = "customer_details";

    static let TABLE_ETORMAPPING = "etormapping";
    static let TABLE_RETAILER_SCANNED_IN_STICKER = "retailer_scaned_in_sticker";
    static let TABLE_RETAILER_SCANNED_OUT_STICKER = "retailer_scaned_out_sticker";

    static let TABLE_YELLOW_LABEL_DISCARD = "bf_ishop_yellow_lable_discard";
    static let TABLE_YELLOW_LABEL_DISCARD_DETAILS = "bf_ishop_yellow_lable_discard_details";

    static let TABLE_SALES_INITIATED_PRODUCT_CURRENT_LIMIT = "sales_rep_initiated_product_current_limit";

    //eVoucher
    static let TABLE_EVOUCHER_SCAN = "table_evoucher_scan";
    static let TABLE_MASTER_CONVERSION = "master_conversion";
    static let KEY_REDEMPTION_DETAIL_ID = "redeemption_details_id";
    static let KEY_SKU_COUNTRY_ID = "sku_country_id";

    static let KEY_CONVERSION_ID = "conversation_id";
    static let KEY_PRODUCT_SKU_ID_CONVERSION = "product_sku_id";
    static let KEY_SKU_CONVERSION_FACTOR = "sku_convesion_factor";
    static let KEY_BOX_CONVERSION_FACTOR = "box_conversion_factor";

    //Blocking Retailer and Distributor
    static let TABLE_SKU_WISE_BLOCKING = "bf_sku_wise_blocking_period_details";
    static let TABLE_BLOCKING_LOOKUP_VALUES = "lookup_values_config";
    static let KEY_INT_ID = "intId";
    static let KEY_PBG_ID_BLOCK = "pbg_id";
    static let KEY_SKU_ID = "sku_id";
    static let KEY_NO_OF_MONTH = "no_of_month";
    static let KEY_BLOCK_SCANNING_CODE = "block_scanning_code";
    static let KEY_BLOCK_SCANNING_BY = "block_scanning_by";

    static let KEY_LOOKUP_TYPE_ID = "lookuptype_id";
    static let KEY_LOOKUP_CODE = "varLookupCode";
    static let KEY_LOOKUP_VALUE = "varLookupValue";


    static let DTMONTH = "dtmonth";
    static let TOTALINSCANNED = "TotalInScanned";
    static let TABLE_RTORMAPPING = "rtormapping";
    static let TABLE_DTORMAPPING = "dtormapping";
    static let TABLE_PRODUCT_TYPE_NAME_COUNTRY = "product_type_name_country";
    static let TABLE_STICKER_DETAILS = "ishop_sticker_details";
    static let TABLE_STICKER_DETAILS_COPY = "ishop_sticker_details_copy";
    static let TABLE_MASTER_PRODUCT_SKU_COUNTRY = "product_sku_country";
    static let TABLE_STICKER = "ishop_sticker";
    static let TABLE_STICKER_COPY = "ishop_sticker_copy";
    static let TABLE_MENU_ACCESS = "Menu_Access";
    static let TABLE_POLITICAL_LEVEL = "political_level";
    static let TABLE_POLITICAL_DETAILS = "political_details";
    static let TABLE_CUSTOMER_PRODUCT_STOCK = "cpm_customer_product_stock";
    static let TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK = "cpm_customer_product_damage_stock";
//    static let TABLE_SAVE_OFFLINE_LOG = "bf_ishop_save_offline_log_android_cpm";
    static let KEY_ID = "id";
    static let KEY_TOLLER_DISPATCH_ID = "toller_dispatch_id";
//    static let KEY_CUSTOMER_FROM_ID = "customer_from_id";
    static let KEY_TOTAL_PRODUCT = "intTotalProduct";
    // COLUMN NAME
    static let KEY_customer_to_name = "customer_to_name";
    //

    /*TOdo change By Praveen */

    static let TABLE_ISHOP_RETAILER_RETURN = "bf_ishop_retailer_return";
    static let RETAILER_RETURN_ID = "retailer_return_id";
    static let RETAILER_RETURN_PRODUCT_ID = "retailer_return_product_id";
    static let TABLE_ISHOP_RETAILER_RETURN_PRODUCT = "bf_ishop_retailer_return_product";

    /**
     * Save Offline Key
     */
    static let KEY_START_TIME = "save_start_date_time";
    static let KEY_END_TIME = "save_end_date_time";
    static let KEY_TOTAL_RECORDS_SAVED = "total_records";
    static let KEY_SAVE_DONE = "save_done";
    static let KEY_VERSION = "version";
    static let KEY_IMEINO = "imei_no";

    static let EXTRA_STICKER_DETAIL_ID = "extra_sticker_detail_id";
    static let EXTRA_STICKER_ID = "extra_sticker_id";
    static let BASE_BTC_NO_OUT = "base_btc_no_out";
    static let BASE_BTC_NO_IN = "base_btc_no_in";
    static let BASE_QR_CODE_IN = "base_qr_code_in ";
    static let BASE_QR_CODE_OUT = "base_qr_code_out";
    static let QR_CODE_IN = "qr_code_in";
    static let QR_CODE_OUT = "qr_code_out";
    static let STICKER_DETAIL_ID = "sticker_details_id";
    static let MAPPED_ON = "mapped_on";
    static let CREATE_BY_USER = "created_by_user";
    static let CREATE_ON = "created_on";
    static let SYNC_CODE = "sync_code";
    static let SYNC_FLAG = "sync_flag";
    static let SYNC_DATE = "sync_date";

    //CREATE_TABLE_DEVICE_TOKEN
//    static let TABLE_DEVICE_TOKEN = "table_device_token";
    static let KEY_DEVICE_TOKEN = "device_token";
    static let KEY_USER_ID = "user_id";

    static let KEY_OUT_POINT_CALCULATE = "out_point_calculate";
    static let KEY_RECEIVE_SCAN_TYPE = "received_scan_type";

    //cpm_customer_product_stock
    static let KEY_DISPATCH_DATE_TIME = "dispatchdatetime";
    static let KEY_STDONO = "doNo";
    static let KEY_new_customer_type = "new_customer_type";
    static let KEY_customer_to_phone = "customer_to_phone";
//    static let KEY_CUSTOMER_TO_ID = "customer_to_id";
    static let KEY_DISPATCH_DATE = "dispatch_date";
//    static let KEY_DOCUMENT_NO = "document_no";
//    static let KEY_COUNTRY_ID = "country_id";
//    static let KEY_CREATED_BY_USER = "created_by_user";
//    static let KEY_MODIFIED_BY_USER = "modified_by_user";
//    static let KEY_STATUS = "status";
//    static let KEY_CREATE_ON = "created_on";
    static let KEY_CREATE_BY = "created_by";
//    static let KEY_MODIFIED_ON = "modified_on";
//    static let KEY_SYNC_CODE = "sync_code";
//    static let KEY_SYNC_FLAG = "sync_flag";
//    static let KEY_SYNC_DATE = "sync_date";
    static let KEY_ANDROID_SYNC = "android_sync";
    static let KEY_PALLET_DETAIL_ID = "pallet_details_id";
    static let KEY_isDispatch = "isDispatch";
//    static let KEY_SYNC_USER = "sync_by_user";
    static let KEY_RECEIVED = "received";
    static let KEY_RECEIVED_DATE = "received_date";
    static let KEY_READ = "isRead";
    static let KEY_IS_DISPATCH = "isDispatch";
    static let KEY_READ_DATE = "read_date";
    static let KEY_TOLLER_DISPATCH_PRODUCT_ID = "toller_dispatch_product_id";
    static let KEY_PRODUCT_SKU_COUNTRY_ID = "product_sku_country_id";
    static let KEY_STICKER_ID = "sticker_id";
    static let KEY_BATCH_NO = "batch_no";
    static let KEY_BATCH_ID = "batch_id";
//    static let KEY_QUANTITY = "quantity";
//    static let KEY_AMOUNT = "amount";
//    static let KEY_UNIT = "unit";
//    static let KEY_QTY_KGL = "qty_kgl";
    static let KEY_CFA_DISPATCH_ID = "cfa_dispatch_id";
    static let KEY_SAP_ID = "sap_id";
    static let KEY_DISPATCH_TYPE = "dispatch_type";
    static let KEY_DO_STO_NO = "do_sto_no";
    static let KEY_DOC_NO = "doc_no";
    static let KEY_CFA_DISPATCH_PRODUCT_ID = "cfa_dispatch_product_id";
//    static let KEY_PRODUCT_SKU_ID = "product_sku_id";
//    static let KEY_STICKER_DETAILS_ID = "sticker_details_id";
    static let KEY_BTC_NO = "btc_no";
//    static let KEY_BTC_NO_OUT = "btc_no_out";
//    static let KEY_IS_VALID = "is_valid";
    static let KEY_DISTRIBUTOR_DISPATCH_ID = "distributor_dispatch_id";
//    static let KEY_CUSTOMER_TYPE_COUNTRY_ID = "customer_type_country_id";
    static let KEY_Customer_type_name_country = "Customer_type_name_country";
    static let KEY_customer_level = "customer_level";
    static let KEY_customer_type_name = "customer_type_name";
//    static let KEY_IS_NEW_CUSTOMER = "is_new_customer";
    static let KEY_DISTRIBUTOR_DISPATCH_PRODUCT_ID = "distributor_dispatch_product_id";
    static let KEY_CUSTOMER_ID = "customer_id";
    static let KEY_CUSTOMER_NAME = "customer_name";
    static let KEY_CUSTOMER_TYPE_COUNTY_ID = "customer_type_country_id";
    static let KEY_MOBILE_NO = "mobile_no";
    static let PRIMARY_MOBILE_NO = "primary_mobile_no";
    static let KEY_RETAILER_DISPATCH_ID = "retailer_dispatch_id";
    static let KEY_RETAILER_DISPATCH_PRODUCT_ID = "retailer_dispatch_product_id";
    static let KEY_BTC_TYPE = "btc_type";
    static let FROM_CUSTOMER_LEVEL = "from_customer_level";
    static let FROM_CUSTOMER_ID = "from_customer_id";
    static let TO_CUSTOMER_LEVEL = "to_customer_level";
    static let TO_CUSTOMER_ID = "to_customer_id";
    static let KEY_RETAILER_RETURN_ID = "retailer_return_id";
//    static let KEY_RETURN_DATE = "return_date";
    static let KEY_RETAILER_RETURN_PRODUCT_ID = "retailer_return_product_id";
//    static let KEY_DISTRIBUTOR_RETURN_ID = "distributor_return_id";
//    static let KEY_DISTRIBUTOR_RETURN_PRODUCT_ID = "distributor_return_product_id";
    static let KEY_DISTRIBUTOR_RETURN_REQUEST_ID = "distributor_return_request_id";
    static let KEY_RETURN_REQUEST_DATE = "return_request_date";
    static let TABLE_CTOCMAPPING = "ctocmapping";
    static let EMPLOYEE_ID = "employee_id";
    static let CUSTOMER_ID = "customer_id";
    static let USER_CODE = "user_code";
    static let DISPLAY_NAME = "display_name";
    static let EMAIL = "email";
    static let KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID =
            "distributor_return_request_product_id";
    static let KEY_CFA_RETURN_ID = "cfa_return_id";
    static let KEY_CFA_RETURN_PRODUCT_ID = "cfa_return_product_id";
    static let KEY_CPM_STOCK_ID = "cpm_stock_id";
    static let KEY_STOCK_DATE = "stock_date";
    static let KEY_CPM_STOCK_DETAILS_ID = "cpm_stock_details_id";
    static let KEY_TRANSACTIONS_TYPE = "tran_type";
    static let KEY_TRANSACTIONS_DATE = "tran_date";
    static let KEY_ENTRY_FROM = "entry_from";
    static let TABLE_CTOEMAPPING = "ctoemapping";
    static let KEY_EMAIL = "email";
    static let KEY_USER_CODE = "user_code";
    static let KEY_BUSSINESS_CODE = "bussiness_code";
    static let KEY_DISPLAY_NAME = "display_name";
    static let KEY_CUSTOMER_TYPE_COUNTRY_CODE = "customer_type_country_code";
    static let KEY_CUSTOMER_TYPE_COUNTRY_NAME = "customer_type_country_name";
    static let KEY_CUSTOMER_TYPE_REGIONAL_ID = "customer_type_regional_id";
    static let KEY_CUSTOMER_TYPE_REGIONAL_NAME = "customer_type_regional_name";
    static let KEY_CUSTOMER_TYPE_REGIONAL_CODE = "customer_type_regional_code";
    static let KEY_CUSTOMER_TYPE_REGIONAL_LEVEL = "customer_regional_level";
    static let KEY_EMPLOYEE_TYPE_REGIONAL_LEVEL = "employee_regional_level";
    static let KEY_PRODUCT_COUNTRY_ID = "product_country_id";
    static let KEY_PRODUCT_REGIONAL_ID = "product_regional_id";
    static let KEY_PRODUCT_COUNTRY_NAME = "product_country_name";
    static let KEY_PRODUCT_REGIONAL_CODE = "product_regional_code";
    static let KEY_DESCRIPTION = "Description";
    static let KEY_DELETED = "deleted";
    static let KEY_BTC_NO_IN = "btc_no_in";
    static let KEY_QR_CODE_IN = "qr_code_in";
//    static let KEY_QR_CODE_OUT = "qr_code_out";
    static let KEY_qr_code = "qr_code";
    static let KEY_STICKER_NO = "sticker_no";
    static let KEY_IS_BUFFER = "isBuffer";
    static let KEY_PRODUCT_SKU_NAME = "product_sku_name";
    static let KEY_PBG_ID = "PBG_ID";
    static let KEY_PRODUCT_SKU_CODE = "product_sku_code";
    static let KEY_REF_ID = "ref_Id";
    static let KEY_SYSTEM_CODE = "system_code";
    static let KEY_TOLLER_CODE = "toller_code";
    static let KEY_PRODUCTION_DATE = "production_date";
    static let KEY_PBG_COUNTRY_ID = "PBG_Country_Id";
    static let KEY_MFG_DATE = "mfg_date";
    static let KEY_EXPIRE_DATE = "expire_date";
    static let KEY_BUFFER = "buffer";
    static let KEY_DRAFT = "draft";
    static let KEY_DRAFT_DATE = "draft_date";
    static let KEY_DRAFT_REASON = "draft_reason";
    static let KEY_ORDER = "orderId";
    static let KEY_ALIAS = "alias";
    static let KEY_MENU_ID = "menu_id";
    static let KEY_TITLE = "title";
    static let KEY_POLITICAL_GEOGRAPHY_COUNTRY_LEVEL_ID =
            "political_geography_countrylevel_id";
    static let KEY_LEVEL_NAME = "level_name";
    static let KEY_LEVEL = "level";
    static let KEY_POLITICAL_GEO_ID = "political_geo_id";
    static let KEY_PARENT_GEO_ID = "parent_geo_id";
    static let KEY_POLITICAL_GEOGRAPHY_CODE = "political_geography_code";
    static let KEY_POLITICAL_GEOGRAPHY_NAME = "political_geography_name";
    static let KEY_MODIFICATION_BY_USER = "modified_by_user";
    static let KEY_REGIONAL_LEVEL = "regional_level";
    static let KEY_GEO_LEVEL_ID = "geo_level_id";
    static let KEY_CUSTOMER_PRODUCT_STOCK_ID = "cpm_customer_product_stock_id";
    static let KEY_CUSTOMER_PRODUCT_DAMAGE_STOCK_ID = "cpm_customer_product_damage_stock_id";
    static let KEY_PRODUCT_STOCK_KGL = "current_stock_kgl";
    static let KEY_CURRENT_LIMIT = "current_limit";
//    static let TABLE_HELP_VIDEO_DETAIL = "bf_master_cpm_help_video_details";

    static let Political_Geo_4 = "political_geo_level_4";
    static let RECIEVE_Days = "intReceiveDays";
//    static let TABLE_HELP_VIDEO_DETAIL = "bf_master_cpm_help_video_details"
    static let VIDEO_TYPE_ID = "video_type_id"
    static let VIDEO_MENU_ID = "video_menu_id"
    static let VIDEO_MENU_NAME = "video_menu_name"
    static let ROLE_ID_IN_VIDEO = "role_id"
    static let VIDEO_FILE_NAME = "file_name"
    static let VIDEO_LOCAL_PATH = "video_local_path"
    static let VIDEO_UPLOAD_TYPE = "upload_type"
    static let VIDEO_CUSTOMER_ID = "customer_id"
    static let IS_DOWNLOADED = "isDownload"
    static let VIDEO_TYPE_DETAIL_ID = "video_type_details_id"
    static let KEY_IMEI_NO = "imeino"

    static let RECIEVE_POPUP = "charReceivePopUp";
    static let CUSTOMER_SYNC_DISABLE = "chr_cust_sync_enable";
    static let KEY_PRODUCT_STOCK_BOX = "current_stock_box";
    static let LOGIN_MASTER = "login";
    static let VAR_USERNAME = "var_username";
    static let VAR_PASSWORD = "var_password";
    // Database creation sql statement
    static let VAR_PERSONNAME = "var_personname";
    static let KEY_COUNTRY_CODE = "country_code";
    static let FK_PERSONGICODE = "fk_personGlcode";
    static let FK_EMPGLCODE = "fk_empGlcode";
    static let VAR_MOBILENUMBER = "var_mobilenumber";
    static let VAR_LASTSYNCTIME = "var_lastsynctime";
    static let VAR_ClIENTNAME = "var_clientname";
    static let IS_AUTHORISED = "is_authorised";
    static let IS_SMSON = "is_smson";
    static let IMEI = "imei";
    static let KEY_PARENT_ID = "parent_id";
    static let KEY_PARENT_USER_ID = "parent_user_id";
    static let INTGLCODE = "intGlCode";
    static let KEY_PRIMARY_MOBILE_NO = "primary_mobile_no";
    // static let KEY_POLITICAL_GEO_ID = "political_geo_id";
    static let KEY_political_geography_countrylevel_id = "political_geography_countrylevel_id";
    static let KEY_political_regional_level = "political_regional_level";
    static let DATABASE_NAME = "F_Re_CPM";
    //New Table
//    static let TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED = "bf_ishop_distributor_received";
    static let TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY = "bf_ishop_distributor_received_copy";
//    static let TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT = "bf_ishop_distributor_received_product";
    static let TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT_COPY =
            "bf_ishop_distributor_received_product_copy";
//    static let TABLE_BF_ISHOP_RETAILER_RECEIVED = "bf_ishop_retailer_received";
    static let TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY = "bf_ishop_retailer_received_copy";
//    static let TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT = "bf_ishop_retailer_received_product";
    static let TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY = "bf_ishop_retailer_received_product_copy";
    static let DISTRIBUTOR_RECEIVED_ID = "distributor_received_id";
    static let RETAILER_RECEIVED_ID = "retailer_received_id";
    static let IS_NEW_CUSTOMER = "is_new_customer";
    static let DISPATCH_date = "dispatch_date";
    static let SYNC_BY_USER = "sync_by_user";
    static let DISTRIBUTOR_RECEIVED_PRODUCT_ID = "distributor_received_product_id";
    static let RETAILER_RECEIVED_PRODUCT_ID = "retailer_received_product_id";
    static let BTC_NO_OUT = "btc_no_out";
    //dispatch_scan_type  Received  Returned
    static let USER_CONFIGURATION_MST = "user_configuration_mst";
    static let DISPATCH_SCAN_TYPE = "dispatch_scan_type";
    static let RECEIVED = "received";
    static let RETURNED = "returned";
    static let IS_DISPATCH_TYPE = "is_dispatch_type";
    static let ID = "IDS";
    static let TABLE_Last_Sync_Date_Time = "Last_Sync_Date_Time";
    /* TODO Change By Praveen */
    static let TABLE_EXTRA_PALLET_STICKER_DETAIL = "bf_ishop_extra_pallet_sticker_details";
    static let TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY = "bf_ishop_extra_pallet_sticker_details_copy";
    static let EXTRA_PALLET_STICKER_DETAIL_ID = "extra_pallet_sticker_detail_id";
    static let BASE_PALLET_SERIAL_NO = "base_pallet_serial_no";
    static let BASE_PALLET_QR_CODE = "base_pallet_qr_code";
    static let PALLET_SERIAL_NO = "pallet_serial_no";
    static let PALLET_QR_CODE = "pallet_qr_code";


    /* WAREHOUSE_DISPATCH_SCM)BY_JAY*/
    static let TABLE_DISPATCH_WAREHOUSE = "bf_scm_cpm_integration_data";
    static let TABLE_DISPATCH_WAREHOUSE_COPY = "bf_scm_cpm_integration_data_copy";
    static let SCM_CPM_ID = "scm_cpm_id";
    static let DO_STO_NO = "do_sto_no";
    static let FROM_USER_ID = "from_user_id";
    static let TO_USER_ID = "to_user_id";
    static let TRUCK_NO = "truck_no";
    static let SHIPMENT_STATUS = "shipment_status";
    static let ARTICLE_ID = "article_id";
    static let BATCH_NO = "batch_no";
    static let DEC_QTY = "dec_qty";
    static let DEC_QTY_KGL = "dec_qty_kgl";
    static let DELETED = "deleted";
    static let CREATED_BY_USER = "created_by_user";
    static let CREATED_ON = "created_on";
    static let MODIFIED_ON = "modified_on";
    static let SRIP_ID = "srip_id";
    static let KEY_PALLET_SERIAL_NO = "pallet_serial_no";
    static let KEY_IS_PARTIAL_DISPATCH = "is_partial_dispatch";
    static let KEY_PARTIAL_DISPATCH_CUSTOMER_ID = "partial_dispatch_customer_id";
    static let KEY_PARTIAL_DISPATCH_DATE = "partial_dispatch_date";
    static let KEY_CREATED_ON = "created_on";
    static let KEY_SYNC_BY_USER = "sync_by_user";
    static let KEY_IS_PALLET_SCAN = "is_pallet_scan";
    
    static let TABLE_ISHOP_PALLET_DETAILS_COPY="bf_ishop_pallet_details_copy";
//    static let TABLE_ISHOP_PALLET_DETAILS_COPY="bf_ishop_pallet_details_copy";
    
    static let KEY_REJECT = "reject"
    static let KEY_REJECT_DATE = "rejected_date"

    static let KEY_REMAINING_STOCK_BOX = "remaining_stock_box"
    static let KEY_NEW_REMAINING_STOCK_BOX = "new_remaining_stock_box"

    static let FK_PBG_COUNTRY_ID = "fk_PBG_Country_id"
    static let FK_SKU_COUNTRY_ID = "fk_Sku_Country_id"
    static let DECQTY = "decQty"
    static let VARREMARKS = "varRemarks"
    static let SCAN_COUNT = "scan_count"
//    static let SRIP_ID = "srip_id"

    static let CREATED_BY_NAME = "created_by_name"
    static let MODIFIED_BY_NAME = "modifed_by_name"
    
    static let KEY_SCHEME_ID = "scheme_id"
    static let KEY_SCHEME_CODE = "scheme_code"
    static let KEY_SCHEME_NAME = "scheme_name"
    static let KEY_FROM_MONTH = "from_month"
    static let KEY_TO_MONTH = "to_month"
    static let KEY_VALUE_PER_POINT = "value_per_point"

    
    static let TABLE_EMPLOYEE_DETAILS = "employee_details";
    static let TABLE_POLITICAL_DETAILS_EMP = "political_detail_emp";
//    static let TABLE_ISHOP_SAMPLE_DISPATCH = "bf_ishop_sample_dispatch";
    static let TABLE_ISHOP_SAMPLE_DISPATCH_COPY = "bf_ishop_sample_dispatch_copy";
//    static let TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT = "bf_ishop_sample_dispatch_product";
    static let TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY = "bf_ishop_sample_dispatch_product_copy";


    static let COL_SAMPLE_DISPATCH_ID = "sample_dispatch_id";
    static let COL_SAMPLE_DISPATCH_PRODUCT_ID = "sample_dispatch_product_id";


    //B2C Config
    static let B2C_CONFIG_TABLE = "b2c_config";
    static let B2C_LOG_DETAILS = "bf_b2c_log_details ";

    static let KEY_IS_B2C = "is_b2c";
    static let KEY_CONFIG_ID = "config_id";
    static let KEY_CONFIG_CODE = "config_code";
    static let KEY_TENANT = "tenant";
    static let KEY_POLICY = "policy";
    static let KEY_CLIENT_ID = "client_id";
    static let KEY_SCOPE = "scope";
    static let KEY_CLIENT_SECRET_KEY = "client_secret_key";
    static let KEY_PLATFORM = "platform";
    static let KEY_METHOD = "method";
    static let KEY_CERTIFICATE_FILE = "certificate_file";
    static let KEY_FILE = "key_file";
    static let KEY_APPLICATION_TYPE = "application_type";

    static let KEY_LOG_ID = "log_id";
    static let KEY_REQUEST_URL = "request_url";
    static let KEY_REQUEST_PARAM = "request_param";
    static let KEY_REQUEST_MESSAGE = "request_message";
    static let KEY_HEADER = "header";
    static let KEY_RESPONSE = "response";
    static let KEY_CODE = "code";
    static let KEY_RESPONSE_STATUS = "response_status";
    static let KEY_PLATFORM_TYPE = "platform";
    static let KEY_START_TIME_LOG = "start_date_time";
    static let KEY_END_TIME__LOG = "end_date_time";

    static let B2C_LOGIN = "b2c_login";

    static let KEY_PHONE_NUMBER = "phoneNumber";
    static let KEY_ACCESSTOKEN = "accesstoken";
    static let KEY_ID_TOKEN = "idToken";
    static let KEY_REFRESH_TOKEN = "refreshToken";
    static let KEY_COUNTRY_CODE_B2C = "country_code";
    static let KEY_TOKEN_EXPIRY = "token_expiry_date";
    static let KEY_SUB = "sub";

    static let AUTO_SYNC = "autosync";
    static let AUTO_SYNC_DAY = "autosyncday";

    
    
    
    
}

/*class ExportDBChiper{
     
     func checkDatabaseEnciptedorPlain(datbasePath:String,password:String) -> Bool {
          
          var rc: Int32 = 0
          var db: OpaquePointer? = nil
          sqlite3_open(datbasePath, &db)
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error opening database: \(errmsg)")
               return false
          }
          
          
          
          //rc = sqlite3_(db, password, Int32(password.utf8CString.count))
          
          //rc = sqlite3_key(db, password, Int32(password.utf8CString.count))
          
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error setting key: \(errmsg)")
                return false
          }
          
           return true
          
          /*var rc: Int32
          var db: OpaquePointer? = nil
          var stmt: OpaquePointer? = nil
          let password: String = "correct horse battery staple"
          rc = sqlite3_open(":memory:", &db)
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error opening database: \(errmsg)")
               return
          }
          rc = sqlite3_key(db, password, Int32(password.utf8CString.count))
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error setting key: \(errmsg)")
          }
          rc = sqlite3_prepare(db, "PRAGMA cipher_version;", -1, &stmt, nil)
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error preparing SQL: \(errmsg)")
          }
          rc = sqlite3_step(stmt)
          if (rc == SQLITE_ROW) {
               NSLog("cipher_version: %s", sqlite3_column_text(stmt, 0))
          } else {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error retrieiving cipher_version: \(errmsg)")
          }
          sqlite3_finalize(stmt)
          sqlite3_close(db)*/
     }
}*/

class JsonInsert{
     
     static func parseJsonCustomer_Partner_Mst(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         var chrTran:String = ""
                         if Tourplan_Daily[k]["chrTran"] == nil {
                              chrTran = ""
                         }else{
                              chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                         }
                         
                         if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                              continue
                         }
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         
                         
                         
                         
                         var varType:String = ""
                         if Tourplan_Daily[k]["varType"] == nil {
                              varType = ""
                         }else{
                              varType = Tourplan_Daily[k]["varType"].stringValue
                         }
                         
                         var fk_From_CustomerGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_From_CustomerGlCode"] == nil {
                              fk_From_CustomerGlCode = 0
                         }else{
                              fk_From_CustomerGlCode = Tourplan_Daily[k]["fk_From_CustomerGlCode"].intValue
                         }
                         
                         var fk_To_CustomerGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_To_CustomerGlCode"] == nil {
                              fk_To_CustomerGlCode = 0
                         }else{
                              fk_To_CustomerGlCode = Tourplan_Daily[k]["fk_To_CustomerGlCode"].intValue
                         }
                         
                         
                         
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:Int = 0
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = 0
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                         }
                         
                         //dtModifiedDate
                         var dtModifiedDate:String = ""
                         if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                              dtModifiedDate = ""
                         }else{
                              dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                         }
                         
                         var ref_Modified_By:Int = 0
                         if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                              ref_Modified_By = 0
                         }else{
                              ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                         }
                         
                         var chrSync:String = ""
                         if Tourplan_Daily[k]["chrSync"] == nil {
                              chrSync = ""
                         }else{
                              chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                         }
                         
                         var dtSyncDate:String = ""
                         if Tourplan_Daily[k]["dtSyncDate"] == nil {
                              dtSyncDate = ""
                         }else{
                              dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                         }
                         
                         var varSync_Code:String = ""
                         if Tourplan_Daily[k]["varSync_Code"] == nil {
                              varSync_Code = ""
                         }else{
                              varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                         }
                         
                         let deleteQuery = "DELETE FROM Customer_Partner_Mst WHERE varSync_Code IN ('\(varSync_Code)')"
                         database.executeUpdate(deleteQuery, withArgumentsIn: [])
                         print("delete from sticker details-----------")
                         
                         
                         try database.executeUpdate("insert into Customer_Partner_Mst ( intGlCode,varType,fk_From_CustomerGlCode,fk_To_CustomerGlCode,chrActive,dtEntryDate,ref_Entry_By,dtModifiedDate,chrSync,dtSyncDate,varSync_Code) values (?,?,?,?,?,?,?,?)", values: [intGlCode,varType,fk_From_CustomerGlCode,fk_To_CustomerGlCode,chrActive,dtEntryDate,ref_Entry_By,dtModifiedDate,chrSync,dtSyncDate,varSync_Code])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error Customer_Partner_Mst")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
     static func parseJsonCPM_PSKU_Batch_Stock(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         
                         
                         var fk_Customer_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_GlCode"] == nil {
                              fk_Customer_GlCode = 0
                         }else{
                              fk_Customer_GlCode = Tourplan_Daily[k]["fk_Customer_GlCode"].intValue
                         }
                         
                         var fk_Product_SKU_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Product_SKU_GlCode"] == nil {
                              fk_Product_SKU_GlCode = 0
                         }else{
                              fk_Product_SKU_GlCode = Tourplan_Daily[k]["fk_Product_SKU_GlCode"].intValue
                         }
                         
                         var fk_UOM_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_UOM_GlCode"] == nil {
                              fk_UOM_GlCode = 0
                         }else{
                              fk_UOM_GlCode = Tourplan_Daily[k]["fk_UOM_GlCode"].intValue
                         }
                         
                         var varBatchNo:String = ""
                         if Tourplan_Daily[k]["varBatchNo"] == nil {
                              varBatchNo = ""
                         }else{
                              varBatchNo = Tourplan_Daily[k]["varBatchNo"].stringValue
                         }
                         
                         var dtExpiryDate:String = ""
                         if Tourplan_Daily[k]["dtExpiryDate"] == nil {
                              dtExpiryDate = ""
                         }else{
                              dtExpiryDate = Tourplan_Daily[k]["dtExpiryDate"].stringValue
                         }
                         
                         var decQty:Double = 0
                         if Tourplan_Daily[k]["decQty"] == nil {
                              decQty = 0
                         }else{
                              decQty = Tourplan_Daily[k]["decQty"].doubleValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         
                         try database.executeUpdate("insert into CPM_PSKU_Batch_Stock ( intGlCode,fk_Customer_GlCode,fk_Product_SKU_GlCode,fk_UOM_GlCode,varBatchNo,dtExpiryDate,decQty,dtEntryDate) values (?,?,?,?,?,?,?,?)", values: [intGlCode,fk_Customer_GlCode,fk_Product_SKU_GlCode,fk_UOM_GlCode,varBatchNo,dtExpiryDate,decQty,dtEntryDate])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error CPM_PSKU_Batch_Stock")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
    
     static func parseJsonCountries_Mst(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         var varCode:String = ""
                         if Tourplan_Daily[k]["varCode"] == nil {
                              varCode = ""
                         }else{
                              varCode = Tourplan_Daily[k]["varCode"].stringValue
                         }
                         
                         var varName:String = ""
                         if Tourplan_Daily[k]["varName"] == nil {
                              varName = ""
                         }else{
                              varName = Tourplan_Daily[k]["varName"].stringValue
                         }
                         
                         var varTime_Zone:String = ""
                         if Tourplan_Daily[k]["varTime_Zone"] == nil {
                              varTime_Zone = ""
                         }else{
                              varTime_Zone = Tourplan_Daily[k]["varTime_Zone"].stringValue
                         }
                         
                         var intUTC_Minute_Diff:String = ""
                         if Tourplan_Daily[k]["intUTC_Minute_Diff"] == nil {
                              intUTC_Minute_Diff = ""
                         }else{
                              intUTC_Minute_Diff = Tourplan_Daily[k]["intUTC_Minute_Diff"].stringValue
                         }
                         
                         var varLatitude:String = ""
                         if Tourplan_Daily[k]["varLatitude"] == nil {
                              varLatitude = ""
                         }else{
                              varLatitude = Tourplan_Daily[k]["varLatitude"].stringValue
                         }
                         
                         var varLongitude:String = ""
                         if Tourplan_Daily[k]["varLongitude"] == nil {
                              varLongitude = ""
                         }else{
                              varLongitude = Tourplan_Daily[k]["varLongitude"].stringValue
                         }
                         
                         var intFinancial_Month:Int = 0
                         if Tourplan_Daily[k]["intFinancial_Month"] == nil {
                              intFinancial_Month = 0
                         }else{
                              intFinancial_Month = Tourplan_Daily[k]["intFinancial_Month"].intValue
                         }
                         
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:String = ""
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = ""
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].stringValue
                         }
                         
                         
                         /*let deleteQuery = "DELETE FROM CPM_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                          self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                          print("delete from sticker details-----------")*/
                         
                         try database.executeUpdate("insert into Countries_Mst ( intGlCode,varCode,varName,varName,varTime_Zone,intUTC_Minute_Diff,varLatitude,varLongitude,intFinancial_Month,chrActive,dtEntryDate,ref_Entry_By) values (?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,varCode,varName,varName,varTime_Zone,intUTC_Minute_Diff,varLatitude,varLongitude,intFinancial_Month,chrActive,dtEntryDate,ref_Entry_By])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error Countries_Mst")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
     static func parseJsonCPM_Customer_Dispatch(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         var chrTran:String = ""
                         if Tourplan_Daily[k]["chrTran"] == nil {
                              chrTran = ""
                         }else{
                              chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                         }
                         
                         if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                              continue
                         }
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         var fk_Customer_From_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_From_GlCode"] == nil {
                              fk_Customer_From_GlCode = 0
                         }else{
                              fk_Customer_From_GlCode = Tourplan_Daily[k]["fk_Customer_From_GlCode"].intValue
                         }
                         
                         var fk_Customer_From_Type_CountryGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_From_Type_CountryGlCode"] == nil {
                              fk_Customer_From_Type_CountryGlCode = 0
                         }else{
                              fk_Customer_From_Type_CountryGlCode = Tourplan_Daily[k]["fk_Customer_From_Type_CountryGlCode"].intValue
                         }
                         
                         var fk_Customer_To_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_To_GlCode"] == nil {
                              fk_Customer_To_GlCode = 0
                         }else{
                              fk_Customer_To_GlCode = Tourplan_Daily[k]["fk_Customer_To_GlCode"].intValue
                         }
                         
                         var fk_Customer_To_Type_CountryGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_To_Type_CountryGlCode"] == nil {
                              fk_Customer_To_Type_CountryGlCode = 0
                         }else{
                              fk_Customer_To_Type_CountryGlCode = Tourplan_Daily[k]["fk_Customer_To_Type_CountryGlCode"].intValue
                         }
                         
                         var fk_Sold_To_Party_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Sold_To_Party_GlCode"] == nil {
                              fk_Sold_To_Party_GlCode = 0
                         }else{
                              fk_Sold_To_Party_GlCode = Tourplan_Daily[k]["fk_Sold_To_Party_GlCode"].intValue
                         }
                         
                         var fk_Sold_To_Party_Type_CountryGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Sold_To_Party_Type_CountryGlCode"] == nil {
                              fk_Sold_To_Party_Type_CountryGlCode = 0
                         }else{
                              fk_Sold_To_Party_Type_CountryGlCode = Tourplan_Daily[k]["fk_Sold_To_Party_Type_CountryGlCode"].intValue
                         }
                         
                         var chrTransType:String = ""
                         if Tourplan_Daily[k]["chrTransType"] == nil {
                              chrTransType = ""
                         }else{
                              chrTransType = Tourplan_Daily[k]["chrTransType"].stringValue
                         }
                         
                         var chrExternal_Customer:String = ""
                         if Tourplan_Daily[k]["chrExternal_Customer"] == nil {
                              chrExternal_Customer = ""
                         }else{
                              chrExternal_Customer = Tourplan_Daily[k]["chrExternal_Customer"].stringValue
                         }
                         
                         var varCustomer_Name:String = ""
                         if Tourplan_Daily[k]["varCustomer_Name"] == nil {
                              varCustomer_Name = ""
                         }else{
                              varCustomer_Name = Tourplan_Daily[k]["varCustomer_Name"].stringValue
                         }
                         
                         var varEmail:String = ""
                         if Tourplan_Daily[k]["varEmail"] == nil {
                              varEmail = ""
                         }else{
                              varEmail = Tourplan_Daily[k]["varEmail"].stringValue
                         }
                         
                         var varMobile:String = ""
                         if Tourplan_Daily[k]["varMobile"] == nil {
                              varMobile = ""
                         }else{
                              varMobile = Tourplan_Daily[k]["varMobile"].stringValue
                         }
                         
                         var varPhone_No:String = ""
                         if Tourplan_Daily[k]["varPhone_No"] == nil {
                              varPhone_No = ""
                         }else{
                              varPhone_No = Tourplan_Daily[k]["varPhone_No"].stringValue
                         }
                         
                         var dtDispatchDate:String = ""
                         if Tourplan_Daily[k]["dtDispatchDate"] == nil {
                              dtDispatchDate = ""
                         }else{
                              dtDispatchDate = Tourplan_Daily[k]["dtDispatchDate"].stringValue
                         }
                         
                         var varSONO:String = ""
                         if Tourplan_Daily[k]["varSONO"] == nil {
                              varSONO = ""
                         }else{
                              varSONO = Tourplan_Daily[k]["varSONO"].stringValue
                         }
                         
                         var varDONO:String = ""
                         if Tourplan_Daily[k]["varDONO"] == nil {
                              varDONO = ""
                         }else{
                              varDONO = Tourplan_Daily[k]["varDONO"].stringValue
                         }
                         
                         var chrValidSave:String = ""
                         if Tourplan_Daily[k]["chrValidSave"] == nil {
                              chrValidSave = ""
                         }else{
                              chrValidSave = Tourplan_Daily[k]["chrValidSave"].stringValue
                         }
                         
                         var chrEditDO:String = ""
                         if Tourplan_Daily[k]["chrEditDO"] == nil {
                              chrEditDO = ""
                         }else{
                              chrEditDO = Tourplan_Daily[k]["chrEditDO"].stringValue
                         }
                         
                         var fk_EditDOBy:Int = 0
                         if Tourplan_Daily[k]["fk_EditDOBy"] == nil {
                              fk_EditDOBy = 0
                         }else{
                              fk_EditDOBy = Tourplan_Daily[k]["fk_EditDOBy"].intValue
                         }
                         
                         var dtEditDODate:String = ""
                         if Tourplan_Daily[k]["dtEditDODate"] == nil {
                              dtEditDODate = ""
                         }else{
                              dtEditDODate = Tourplan_Daily[k]["dtEditDODate"].stringValue
                         }
                         
                         var chrCancelDO:String = ""
                         if Tourplan_Daily[k]["chrCancelDO"] == nil {
                              chrCancelDO = ""
                         }else{
                              chrCancelDO = Tourplan_Daily[k]["chrCancelDO"].stringValue
                         }
                         
                         var fk_CancelDOBy:String = ""
                         if Tourplan_Daily[k]["fk_CancelDOBy"] == nil {
                              fk_CancelDOBy = ""
                         }else{
                              fk_CancelDOBy = Tourplan_Daily[k]["fk_CancelDOBy"].stringValue
                         }
                         
                         var dtCancelDODate:String = ""
                         if Tourplan_Daily[k]["dtCancelDODate"] == nil {
                              dtCancelDODate = ""
                         }else{
                              dtCancelDODate = Tourplan_Daily[k]["dtCancelDODate"].stringValue
                         }
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         var chrCompleted:String = ""
                         if Tourplan_Daily[k]["chrCompleted"] == nil {
                              chrCompleted = ""
                         }else{
                              chrCompleted = Tourplan_Daily[k]["chrCompleted"].stringValue
                         }
                         
                         var dtCompletedDate:String = ""
                         if Tourplan_Daily[k]["dtCompletedDate"] == nil {
                              dtCompletedDate = ""
                         }else{
                              dtCompletedDate = Tourplan_Daily[k]["dtCompletedDate"].stringValue
                         }
                         var chrSync:String = ""
                         if Tourplan_Daily[k]["chrSync"] == nil {
                              chrSync = ""
                         }else{
                              chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                         }
                         
                         var varSync_Code:String = ""
                         if Tourplan_Daily[k]["varSync_Code"] == nil {
                              varSync_Code = ""
                         }else{
                              varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                         }
                         
                         var dtSyncDate:String = ""
                         if Tourplan_Daily[k]["dtSyncDate"] == nil {
                              dtSyncDate = ""
                         }else{
                              dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:String = ""
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = ""
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].stringValue
                         }
                         
                         var dtModifiedDate:String = ""
                         if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                              dtModifiedDate = ""
                         }else{
                              dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                         }
                         
                         var ref_Modified_By:Int = 0
                         if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                              ref_Modified_By = 0
                         }else{
                              ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                         }
                         
                         
                         
                         let deleteQuery = "DELETE FROM CPM_Customer_Dispatch WHERE varSync_Code IN ('\(varSync_Code)')"
                         database.executeUpdate(deleteQuery, withArgumentsIn: [])
                         print("delete from CPM_Customer_Dispatch-----------")
                         
                         
                         
                         try database.executeUpdate("insert into CPM_Customer_Dispatch ( intGlCode,fk_Customer_From_GlCode,fk_Customer_From_Type_CountryGlCode,fk_Customer_To_GlCode,fk_Customer_To_Type_CountryGlCode,fk_Sold_To_Party_GlCode,fk_Sold_To_Party_Type_CountryGlCode,chrTransType,chrExternal_Customer,varCustomer_Name,varEmail,varMobile,varPhone_No,dtDispatchDate,varSONO,varDONO,chrValidSave,chrEditDO,fk_EditDOBy,dtEditDODate,chrCancelDO,fk_CancelDOBy,dtCancelDODate,chrActive,chrCompleted,dtCompletedDate,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,fk_Customer_From_GlCode,fk_Customer_From_Type_CountryGlCode,fk_Customer_To_GlCode,fk_Customer_To_Type_CountryGlCode,fk_Sold_To_Party_GlCode,fk_Sold_To_Party_Type_CountryGlCode,chrTransType,chrExternal_Customer,varCustomer_Name,varEmail,varMobile,varPhone_No,dtDispatchDate,varSONO,varDONO,chrValidSave,chrEditDO,fk_EditDOBy,dtEditDODate,chrCancelDO,fk_CancelDOBy,dtCancelDODate,chrActive,chrCompleted,dtCompletedDate,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error CPM_Customer_Dispatch")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
     static func parseJsonStickerDetails(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         let chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                         
                         if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                              continue
                         }
                         
                         let intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         let fk_StickerGlCode = Tourplan_Daily[k]["fk_StickerGlCode"].intValue
                         let varRef_Id = Tourplan_Daily[k]["varRef_Id"].stringValue
                         let varSystem_Name = Tourplan_Daily[k]["varSystem_Name"].stringValue
                         let fk_CustomerGlCode = Tourplan_Daily[k]["fk_CustomerGlCode"].intValue
                         let fk_CountryGlCode = Tourplan_Daily[k]["fk_CountryGlCode"].intValue
                         let fk_PBGGlCode = Tourplan_Daily[k]["fk_PBGGlCode"].intValue
                         let fk_PRDGlCode = Tourplan_Daily[k]["fk_PRDGlCode"].intValue
                         var fk_Product_SKUGlCode : Int = 0
                         
                         
                         if Tourplan_Daily[k]["fk_Product_SKUGlCode"] == nil {
                              fk_Product_SKUGlCode = 0
                         }else{
                              fk_Product_SKUGlCode = Tourplan_Daily[k]["fk_Product_SKUGlCode"].intValue
                         }
                         
                         
                         let varStickerType = Tourplan_Daily[k]["varStickerType"].stringValue
                         let varDINo = Tourplan_Daily[k]["varDINo"].stringValue
                         let varBatch_No = Tourplan_Daily[k]["varBatch_No"].stringValue
                         
                         var dtMFGDate:String = ""
                         if Tourplan_Daily[k]["dtMFGDate"] == nil {
                              dtMFGDate = ""
                         }else{
                              dtMFGDate = Tourplan_Daily[k]["dtMFGDate"].stringValue
                         }
                         
                         let dtExpireDate = Tourplan_Daily[k]["dtExpireDate"].stringValue
                         let varSticker_From_Range = Tourplan_Daily[k]["varSticker_From_Range"].stringValue
                         let varSticker_To_Range = Tourplan_Daily[k]["varSticker_To_Range"].stringValue
                         let varBTC_No_In = Tourplan_Daily[k]["varBTC_No_In"].stringValue
                         let varBTC_No_Out = Tourplan_Daily[k]["varBTC_No_Out"].stringValue
                         let varQR_Code_In = Tourplan_Daily[k]["varQR_Code_In"].stringValue
                         let varQR_Code_Out = Tourplan_Daily[k]["varQR_Code_Out"].stringValue
                         
                         let varSticker_No = Tourplan_Daily[k]["varSticker_No"].stringValue
                         let fk_StatusGlCode = Tourplan_Daily[k]["fk_StatusGlCode"].intValue
                         let fk_Sticker_GeneratedBy = Tourplan_Daily[k]["fk_Sticker_GeneratedBy"].intValue
                         let dtSticker_GeneratedDate = Tourplan_Daily[k]["dtSticker_GeneratedDate"].stringValue
                         
                         var chrExternal_Customer:String = ""
                         if Tourplan_Daily[k]["chrExternal_Customer"] == nil {
                              chrExternal_Customer = ""
                         }else{
                              chrExternal_Customer = Tourplan_Daily[k]["chrExternal_Customer"].stringValue
                         }
                         
                         let fk_Last_DispatchedBy = Tourplan_Daily[k]["fk_Last_DispatchedBy"].intValue
                         let fk_Last_PreviousDispatchBy = Tourplan_Daily[k]["fk_Last_PreviousDispatchBy"].intValue
                         let fk_Last_DispatchedTo = Tourplan_Daily[k]["fk_Last_DispatchedTo"].intValue
                         
                         let dtLast_DispatchedDate = Tourplan_Daily[k]["dtLast_DispatchedDate"].stringValue
                         let fk_Last_ReceivedBy = Tourplan_Daily[k]["fk_Last_ReceivedBy"].intValue
                         
                         var dtLast_RejectedDate:String = ""
                         if Tourplan_Daily[k]["dtLast_RejectedDate"] == nil {
                              dtLast_RejectedDate = ""
                         }else{
                              dtLast_RejectedDate = Tourplan_Daily[k]["dtLast_RejectedDate"].stringValue
                         }
                         
                         var chrDamage:String = ""
                         if Tourplan_Daily[k]["chrDamage"] == nil {
                              chrDamage = ""
                         }else{
                              chrDamage = Tourplan_Daily[k]["chrDamage"].stringValue
                         }
                         
                         var dtDamageDateTime:String = ""
                         if Tourplan_Daily[k]["dtDamageDateTime"] == nil {
                              dtDamageDateTime = ""
                         }else{
                              dtDamageDateTime = Tourplan_Daily[k]["dtDamageDateTime"].stringValue
                         }
                         
                         let fk_DamageBy = Tourplan_Daily[k]["fk_DamageBy"].intValue
                         
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         
                         var chrSync:String = ""
                         if Tourplan_Daily[k]["chrSync"] == nil {
                              chrSync = ""
                         }else{
                              chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                         }
                         
                         var varSync_Code:String = ""
                         if Tourplan_Daily[k]["varSync_Code"] == nil {
                              varSync_Code = ""
                         }else{
                              varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                         }
                         
                         var dtSyncDate:String = ""
                         if Tourplan_Daily[k]["dtSyncDate"] == nil {
                              dtSyncDate = ""
                         }else{
                              dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:Int = 0
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = 0
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                         }
                         
                         
                         var intPrintQty:Int = 0
                         if Tourplan_Daily[k]["intPrintQty"] == nil {
                              intPrintQty = 0
                         }else{
                              intPrintQty = Tourplan_Daily[k]["intPrintQty"].intValue
                         }
                         
                         var dtModifiedDate:String = ""
                         if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                              dtModifiedDate = ""
                         }else{
                              dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                         }
                         
                         var ref_Modified_By:Int = 0
                         if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                              ref_Modified_By = 0
                         }else{
                              ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                         }
                         
                         var fk_Last_RejectedBy:Int = 0
                         if Tourplan_Daily[k]["fk_Last_RejectedBy"] == nil {
                              ref_Modified_By = 0
                         }else{
                              fk_Last_RejectedBy = Tourplan_Daily[k]["fk_Last_RejectedBy"].intValue
                         }
                         
                         
                         
                         var varLastStage:String = ""
                         if Tourplan_Daily[k]["varLastStage"] == nil {
                              varLastStage = ""
                         }else{
                              varLastStage = Tourplan_Daily[k]["varLastStage"].stringValue
                         }
                         
                         var dtLast_ReceivedDate:String = ""
                         if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                              dtLast_ReceivedDate = ""
                         }else{
                              dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                         }
                         
                         
                         let deleteQuery = "DELETE FROM CPM_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                         database.executeUpdate(deleteQuery, withArgumentsIn: [])
                         print("delete from sticker details-----------")
                         
                         try database.executeUpdate("insert into CPM_Sticker_Details ( fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error Tourplan_Daily")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
}
